
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Analytics_eventsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const analytics_events = await db.analytics_events.create(
            {
                id: data.id || undefined,
        
        event_name: data.event_name
        ||
        null
            ,
            
        event_properties: data.event_properties
        ||
        null
            ,
            
        event_at: data.event_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await analytics_events.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return analytics_events;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const analytics_eventsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                event_name: item.event_name
            ||
            null
            ,
            
                event_properties: item.event_properties
            ||
            null
            ,
            
                event_at: item.event_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const analytics_events = await db.analytics_events.bulkCreate(analytics_eventsData, { transaction });

        // For each item created, replace relation files
        

        return analytics_events;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const analytics_events = await db.analytics_events.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.event_name !== undefined) updatePayload.event_name = data.event_name;
        
        
        if (data.event_properties !== undefined) updatePayload.event_properties = data.event_properties;
        
        
        if (data.event_at !== undefined) updatePayload.event_at = data.event_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await analytics_events.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await analytics_events.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return analytics_events;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const analytics_events = await db.analytics_events.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of analytics_events) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of analytics_events) {
                await record.destroy({transaction});
            }
        });


        return analytics_events;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const analytics_events = await db.analytics_events.findByPk(id, options);

        await analytics_events.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await analytics_events.destroy({
            transaction
        });

        return analytics_events;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const analytics_events = await db.analytics_events.findOne(
            { where },
            { transaction },
        );

        if (!analytics_events) {
            return analytics_events;
        }

        const output = analytics_events.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await analytics_events.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.event_properties) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'analytics_events',
                        'event_properties',
                        filter.event_properties,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            event_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    event_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.event_atRange) {
                const [start, end] = filter.event_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    event_at: {
                    ...where.event_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    event_at: {
                    ...where.event_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.event_name) {
                where = {
                    ...where,
                event_name: filter.event_name,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.analytics_events.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'analytics_events',
                        'event_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.analytics_events.findAll({
            attributes: [ 'id', 'event_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['event_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.event_name,
        }));
    }

    
};

